;
; ZX81VARS.INC
; include file with variables used by Sinclair ZX81
; for FASMZ80 (flatassembler with Z80 instruction set)
;
; V1.0
; (C)opyright by Karl-Heinz Dahlmann, Mnchen
;

	include 'ZX81DEF.INC'		; definitions of constants


	ORG		MEMST		; begin of system variables fro ZX81
ERR_NR: 				; error flag (error-1, FF => 0)
	ORG		MEMST+1
FLAGS:					; system flags, see ZX81DEF.INC for explanation
	ORG		MEMST+2
ERR_SP: 				; begin of GOSUB stack
	ORG		MEMST+4
RAMTOP: 				; top of RAM, first non existing memory location
	ORG		MEMST+6
MODE:					; cursor mode (K/L)
	ORG		MEMST+7
PPC:					; line number executing

	ORG		MEMST+9
SAVE_BEGIN:
	VERSN		db 0		; version, 0=ZX81 BASIC
	E_PPC		dw 0		; number of current line with cursor (in listing)
	D_FILE		dw 0		; begin of D_FILE (display file) in memory
	DF_CC		dw 0		; current cursor position in D_FILE (used for print routine)

	VARS		dw 0		; begin of variable section in memory
	DEST		dw 0		; address of variable in assignment

	E_LINE		dw WORKSPACE	; address of workspace
	CH_ADD		dw 0		; address of next character to be interpreted
	X_PTR		dw 0		; address of character preceeding "S" marker

	STKBOT		dw 0		; stack botton (top-down)
	STKEND		dw 0		; end of stack (top)
	BERG		db 0		; calculators b register, possibly write error, should be BREG :-)

	MEM		dw 0		; address for calculator's memory
	UNUSED_1	db 0		; unused variable / space
	DF_SZ		db 0		; no. of lines in lower part of screen including 1 blank line
	S_TOP		dw 0		; no. of top program line in automatic listings
	LAST_K		dw 0		; last key pressed
	DEBOUNCE	db 0		; debounce status of keyboard
	MARGIN		db 0		; margin value, could be used PAL or NTSC
	NXTLIN		dw AUTORUN	; next line to be executed

	OLDPPC		dw 0		; line to jump when executing CONT (continue)
	FLAGX		db 0		; internal flags
	STRLEN		dw 0		; length of string, internally used

	T_ADDR		dw 0		; next item in syntax (token) table

	SEED		dw 0		; seed variable set by RAND

	FRAMES		dw $0000	; counter of frames sent to TV, used by PAUSE command
			LD D,1
			LD HL,$4008
	CDFLAG		db FAST_MODE	; compute and display flag

	include 	'ZX81FALD.INC'

			 db 16509-$ dup(0)

PROG_AREA:

